<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN" "http://www.w3.org/TR/html4/loose.dtd">
<!-- NewPage -->
<html lang="en">
<head>
<!-- Generated by javadoc (1.8.0_202) on Sat Apr 27 15:39:24 CEST 2019 -->
<title>AbstractFbStatement (Jaybird API)</title>
<meta name="date" content="2019-04-27">
<link rel="stylesheet" type="text/css" href="../../../../stylesheet.css" title="Style">
<script type="text/javascript" src="../../../../script.js"></script>
</head>
<body>
<script type="text/javascript"><!--
    try {
        if (location.href.indexOf('is-external=true') == -1) {
            parent.document.title="AbstractFbStatement (Jaybird API)";
        }
    }
    catch(err) {
    }
//-->
var methods = {"i0":10,"i1":10,"i2":10,"i3":10,"i4":10,"i5":10,"i6":10,"i7":10,"i8":10,"i9":10,"i10":6,"i11":10,"i12":10,"i13":10,"i14":10,"i15":10,"i16":10,"i17":10,"i18":10,"i19":10,"i20":10,"i21":10,"i22":10,"i23":10,"i24":10,"i25":10,"i26":10,"i27":10,"i28":10,"i29":6,"i30":10,"i31":10,"i32":10,"i33":10,"i34":10,"i35":10,"i36":10,"i37":10,"i38":10,"i39":10,"i40":10,"i41":10,"i42":10,"i43":10};
var tabs = {65535:["t0","All Methods"],2:["t2","Instance Methods"],4:["t3","Abstract Methods"],8:["t4","Concrete Methods"]};
var altColor = "altColor";
var rowColor = "rowColor";
var tableTab = "tableTab";
var activeTableTab = "activeTableTab";
</script>
<noscript>
<div>JavaScript is disabled on your browser.</div>
</noscript>
<!-- ========= START OF TOP NAVBAR ======= -->
<div class="topNav"><a name="navbar.top">
<!--   -->
</a>
<div class="skipNav"><a href="#skip.navbar.top" title="Skip navigation links">Skip navigation links</a></div>
<a name="navbar.top.firstrow">
<!--   -->
</a>
<ul class="navList" title="Navigation">
<li><a href="../../../../overview-summary.html">Overview</a></li>
<li><a href="package-summary.html">Package</a></li>
<li class="navBarCell1Rev">Class</li>
<li><a href="package-tree.html">Tree</a></li>
<li><a href="../../../../deprecated-list.html">Deprecated</a></li>
<li><a href="../../../../index-all.html">Index</a></li>
<li><a href="../../../../help-doc.html">Help</a></li>
</ul>
</div>
<div class="subNav">
<ul class="navList">
<li><a href="../../../../org/firebirdsql/gds/ng/AbstractFbService.html" title="class in org.firebirdsql.gds.ng"><span class="typeNameLink">Prev&nbsp;Class</span></a></li>
<li><a href="../../../../org/firebirdsql/gds/ng/AbstractFbTransaction.html" title="class in org.firebirdsql.gds.ng"><span class="typeNameLink">Next&nbsp;Class</span></a></li>
</ul>
<ul class="navList">
<li><a href="../../../../index.html?org/firebirdsql/gds/ng/AbstractFbStatement.html" target="_top">Frames</a></li>
<li><a href="AbstractFbStatement.html" target="_top">No&nbsp;Frames</a></li>
</ul>
<ul class="navList" id="allclasses_navbar_top">
<li><a href="../../../../allclasses-noframe.html">All&nbsp;Classes</a></li>
</ul>
<div>
<script type="text/javascript"><!--
  allClassesLink = document.getElementById("allclasses_navbar_top");
  if(window==top) {
    allClassesLink.style.display = "block";
  }
  else {
    allClassesLink.style.display = "none";
  }
  //-->
</script>
</div>
<div>
<ul class="subNavList">
<li>Summary:&nbsp;</li>
<li>Nested&nbsp;|&nbsp;</li>
<li><a href="#field.summary">Field</a>&nbsp;|&nbsp;</li>
<li><a href="#constructor.summary">Constr</a>&nbsp;|&nbsp;</li>
<li><a href="#method.summary">Method</a></li>
</ul>
<ul class="subNavList">
<li>Detail:&nbsp;</li>
<li><a href="#field.detail">Field</a>&nbsp;|&nbsp;</li>
<li><a href="#constructor.detail">Constr</a>&nbsp;|&nbsp;</li>
<li><a href="#method.detail">Method</a></li>
</ul>
</div>
<a name="skip.navbar.top">
<!--   -->
</a></div>
<!-- ========= END OF TOP NAVBAR ========= -->
<!-- ======== START OF CLASS DATA ======== -->
<div class="header">
<div class="subTitle">org.firebirdsql.gds.ng</div>
<h2 title="Class AbstractFbStatement" class="title">Class AbstractFbStatement</h2>
</div>
<div class="contentContainer">
<ul class="inheritance">
<li><a href="https://docs.oracle.com/javase/8/docs/api/java/lang/Object.html?is-external=true" title="class or interface in java.lang">java.lang.Object</a></li>
<li>
<ul class="inheritance">
<li>org.firebirdsql.gds.ng.AbstractFbStatement</li>
</ul>
</li>
</ul>
<div class="description">
<ul class="blockList">
<li class="blockList">
<dl>
<dt>All Implemented Interfaces:</dt>
<dd><a href="../../../../org/firebirdsql/gds/ng/FbStatement.html" title="interface in org.firebirdsql.gds.ng">FbStatement</a>, <a href="../../../../org/firebirdsql/gds/ng/listeners/ExceptionListenable.html" title="interface in org.firebirdsql.gds.ng.listeners">ExceptionListenable</a></dd>
</dl>
<dl>
<dt>Direct Known Subclasses:</dt>
<dd><a href="../../../../org/firebirdsql/gds/ng/wire/AbstractFbWireStatement.html" title="class in org.firebirdsql.gds.ng.wire">AbstractFbWireStatement</a>, <a href="../../../../org/firebirdsql/gds/ng/jna/JnaStatement.html" title="class in org.firebirdsql.gds.ng.jna">JnaStatement</a></dd>
</dl>
<hr>
<br>
<pre>public abstract class <span class="typeNameLabel">AbstractFbStatement</span>
extends <a href="https://docs.oracle.com/javase/8/docs/api/java/lang/Object.html?is-external=true" title="class or interface in java.lang">Object</a>
implements <a href="../../../../org/firebirdsql/gds/ng/FbStatement.html" title="interface in org.firebirdsql.gds.ng">FbStatement</a></pre>
<dl>
<dt><span class="simpleTagLabel">Since:</span></dt>
<dd>3.0</dd>
<dt><span class="simpleTagLabel">Author:</span></dt>
<dd><a href="mailto:mrotteveel@users.sourceforge.net">Mark Rotteveel</a></dd>
</dl>
</li>
</ul>
</div>
<div class="summary">
<ul class="blockList">
<li class="blockList">
<!-- =========== FIELD SUMMARY =========== -->
<ul class="blockList">
<li class="blockList"><a name="field.summary">
<!--   -->
</a>
<h3>Field Summary</h3>
<table class="memberSummary" border="0" cellpadding="3" cellspacing="0" summary="Field Summary table, listing fields, and an explanation">
<caption><span>Fields</span><span class="tabEnd">&nbsp;</span></caption>
<tr>
<th class="colFirst" scope="col">Modifier and Type</th>
<th class="colLast" scope="col">Field and Description</th>
</tr>
<tr class="altColor">
<td class="colFirst"><code>protected <a href="../../../../org/firebirdsql/gds/ng/listeners/ExceptionListenerDispatcher.html" title="class in org.firebirdsql.gds.ng.listeners">ExceptionListenerDispatcher</a></code></td>
<td class="colLast"><code><span class="memberNameLink"><a href="../../../../org/firebirdsql/gds/ng/AbstractFbStatement.html#exceptionListenerDispatcher">exceptionListenerDispatcher</a></span></code>&nbsp;</td>
</tr>
<tr class="rowColor">
<td class="colFirst"><code>protected <a href="../../../../org/firebirdsql/gds/ng/listeners/StatementListenerDispatcher.html" title="class in org.firebirdsql.gds.ng.listeners">StatementListenerDispatcher</a></code></td>
<td class="colLast"><code><span class="memberNameLink"><a href="../../../../org/firebirdsql/gds/ng/AbstractFbStatement.html#statementListenerDispatcher">statementListenerDispatcher</a></span></code>&nbsp;</td>
</tr>
</table>
</li>
</ul>
<!-- ======== CONSTRUCTOR SUMMARY ======== -->
<ul class="blockList">
<li class="blockList"><a name="constructor.summary">
<!--   -->
</a>
<h3>Constructor Summary</h3>
<table class="memberSummary" border="0" cellpadding="3" cellspacing="0" summary="Constructor Summary table, listing constructors, and an explanation">
<caption><span>Constructors</span><span class="tabEnd">&nbsp;</span></caption>
<tr>
<th class="colFirst" scope="col">Modifier</th>
<th class="colLast" scope="col">Constructor and Description</th>
</tr>
<tr class="altColor">
<td class="colFirst"><code>protected </code></td>
<td class="colLast"><code><span class="memberNameLink"><a href="../../../../org/firebirdsql/gds/ng/AbstractFbStatement.html#AbstractFbStatement-java.lang.Object-">AbstractFbStatement</a></span>(<a href="https://docs.oracle.com/javase/8/docs/api/java/lang/Object.html?is-external=true" title="class or interface in java.lang">Object</a>&nbsp;syncObject)</code>&nbsp;</td>
</tr>
</table>
</li>
</ul>
<!-- ========== METHOD SUMMARY =========== -->
<ul class="blockList">
<li class="blockList"><a name="method.summary">
<!--   -->
</a>
<h3>Method Summary</h3>
<table class="memberSummary" border="0" cellpadding="3" cellspacing="0" summary="Method Summary table, listing methods, and an explanation">
<caption><span id="t0" class="activeTableTab"><span>All Methods</span><span class="tabEnd">&nbsp;</span></span><span id="t2" class="tableTab"><span><a href="javascript:show(2);">Instance Methods</a></span><span class="tabEnd">&nbsp;</span></span><span id="t3" class="tableTab"><span><a href="javascript:show(4);">Abstract Methods</a></span><span class="tabEnd">&nbsp;</span></span><span id="t4" class="tableTab"><span><a href="javascript:show(8);">Concrete Methods</a></span><span class="tabEnd">&nbsp;</span></span></caption>
<tr>
<th class="colFirst" scope="col">Modifier and Type</th>
<th class="colLast" scope="col">Method and Description</th>
</tr>
<tr id="i0" class="altColor">
<td class="colFirst"><code>void</code></td>
<td class="colLast"><code><span class="memberNameLink"><a href="../../../../org/firebirdsql/gds/ng/AbstractFbStatement.html#addExceptionListener-org.firebirdsql.gds.ng.listeners.ExceptionListener-">addExceptionListener</a></span>(<a href="../../../../org/firebirdsql/gds/ng/listeners/ExceptionListener.html" title="interface in org.firebirdsql.gds.ng.listeners">ExceptionListener</a>&nbsp;listener)</code>
<div class="block">Adds an exception listener to this object.</div>
</td>
</tr>
<tr id="i1" class="rowColor">
<td class="colFirst"><code>void</code></td>
<td class="colLast"><code><span class="memberNameLink"><a href="../../../../org/firebirdsql/gds/ng/AbstractFbStatement.html#addStatementListener-org.firebirdsql.gds.ng.listeners.StatementListener-">addStatementListener</a></span>(<a href="../../../../org/firebirdsql/gds/ng/listeners/StatementListener.html" title="interface in org.firebirdsql.gds.ng.listeners">StatementListener</a>&nbsp;statementListener)</code>
<div class="block">Registers a <a href="../../../../org/firebirdsql/gds/ng/listeners/StatementListener.html" title="interface in org.firebirdsql.gds.ng.listeners"><code>StatementListener</code></a>.</div>
</td>
</tr>
<tr id="i2" class="altColor">
<td class="colFirst"><code>protected void</code></td>
<td class="colLast"><code><span class="memberNameLink"><a href="../../../../org/firebirdsql/gds/ng/AbstractFbStatement.html#checkStatementValid--">checkStatementValid</a></span>()</code>
<div class="block">Checks if this statement is not in <a href="../../../../org/firebirdsql/gds/ng/StatementState.html#CLOSED"><code>StatementState.CLOSED</code></a>, <a href="../../../../org/firebirdsql/gds/ng/StatementState.html#CLOSING"><code>StatementState.CLOSING</code></a>,
 <a href="../../../../org/firebirdsql/gds/ng/StatementState.html#NEW"><code>StatementState.NEW</code></a> or <a href="../../../../org/firebirdsql/gds/ng/StatementState.html#ERROR"><code>StatementState.ERROR</code></a>, and throws an <code>SQLException</code> if it is.</div>
</td>
</tr>
<tr id="i3" class="rowColor">
<td class="colFirst"><code>void</code></td>
<td class="colLast"><code><span class="memberNameLink"><a href="../../../../org/firebirdsql/gds/ng/AbstractFbStatement.html#close--">close</a></span>()</code>
<div class="block">Close and deallocate this statement.</div>
</td>
</tr>
<tr id="i4" class="altColor">
<td class="colFirst"><code>void</code></td>
<td class="colLast"><code><span class="memberNameLink"><a href="../../../../org/firebirdsql/gds/ng/AbstractFbStatement.html#closeCursor--">closeCursor</a></span>()</code>
<div class="block">Closes the cursor associated with this statement, leaving the
 statement itself allocated.</div>
</td>
</tr>
<tr id="i5" class="rowColor">
<td class="colFirst"><code>void</code></td>
<td class="colLast"><code><span class="memberNameLink"><a href="../../../../org/firebirdsql/gds/ng/AbstractFbStatement.html#closeCursor-boolean-">closeCursor</a></span>(boolean&nbsp;transactionEnd)</code>
<div class="block">Closes the cursor associated with this statement, leaving the statement itself allocated.</div>
</td>
</tr>
<tr id="i6" class="altColor">
<td class="colFirst"><code>protected <a href="../../../../org/firebirdsql/gds/ng/ExecutionPlanProcessor.html" title="class in org.firebirdsql.gds.ng">ExecutionPlanProcessor</a></code></td>
<td class="colLast"><code><span class="memberNameLink"><a href="../../../../org/firebirdsql/gds/ng/AbstractFbStatement.html#createExecutionPlanProcessor--">createExecutionPlanProcessor</a></span>()</code>&nbsp;</td>
</tr>
<tr id="i7" class="rowColor">
<td class="colFirst"><code>protected <a href="../../../../org/firebirdsql/gds/ng/SqlCountProcessor.html" title="class in org.firebirdsql.gds.ng">SqlCountProcessor</a></code></td>
<td class="colLast"><code><span class="memberNameLink"><a href="../../../../org/firebirdsql/gds/ng/AbstractFbStatement.html#createSqlCountProcessor--">createSqlCountProcessor</a></span>()</code>&nbsp;</td>
</tr>
<tr id="i8" class="altColor">
<td class="colFirst"><code>void</code></td>
<td class="colLast"><code><span class="memberNameLink"><a href="../../../../org/firebirdsql/gds/ng/AbstractFbStatement.html#ensureClosedCursor-boolean-">ensureClosedCursor</a></span>(boolean&nbsp;transactionEnd)</code>
<div class="block">Ensures that the statement cursor is closed.</div>
</td>
</tr>
<tr id="i9" class="rowColor">
<td class="colFirst"><code>protected void</code></td>
<td class="colLast"><code><span class="memberNameLink"><a href="../../../../org/firebirdsql/gds/ng/AbstractFbStatement.html#finalize--">finalize</a></span>()</code>&nbsp;</td>
</tr>
<tr id="i10" class="altColor">
<td class="colFirst"><code>protected abstract void</code></td>
<td class="colLast"><code><span class="memberNameLink"><a href="../../../../org/firebirdsql/gds/ng/AbstractFbStatement.html#free-int-">free</a></span>(int&nbsp;option)</code>
<div class="block">Frees the currently allocated statement (either close the cursor with <a href="../../../../org/firebirdsql/gds/ISCConstants.html#DSQL_close"><code>ISCConstants.DSQL_close</code></a> or drop the statement
 handle using <a href="../../../../org/firebirdsql/gds/ISCConstants.html#DSQL_drop"><code>ISCConstants.DSQL_drop</code></a>.</div>
</td>
</tr>
<tr id="i11" class="rowColor">
<td class="colFirst"><code><a href="https://docs.oracle.com/javase/8/docs/api/java/lang/String.html?is-external=true" title="class or interface in java.lang">String</a></code></td>
<td class="colLast"><code><span class="memberNameLink"><a href="../../../../org/firebirdsql/gds/ng/AbstractFbStatement.html#getExecutionPlan--">getExecutionPlan</a></span>()</code>&nbsp;</td>
</tr>
<tr id="i12" class="altColor">
<td class="colFirst"><code><a href="https://docs.oracle.com/javase/8/docs/api/java/lang/String.html?is-external=true" title="class or interface in java.lang">String</a></code></td>
<td class="colLast"><code><span class="memberNameLink"><a href="../../../../org/firebirdsql/gds/ng/AbstractFbStatement.html#getExplainedExecutionPlan--">getExplainedExecutionPlan</a></span>()</code>&nbsp;</td>
</tr>
<tr id="i13" class="rowColor">
<td class="colFirst"><code><a href="../../../../org/firebirdsql/gds/ng/fields/RowDescriptor.html" title="class in org.firebirdsql.gds.ng.fields">RowDescriptor</a></code></td>
<td class="colLast"><code><span class="memberNameLink"><a href="../../../../org/firebirdsql/gds/ng/AbstractFbStatement.html#getFieldDescriptor--">getFieldDescriptor</a></span>()</code>&nbsp;</td>
</tr>
<tr id="i14" class="altColor">
<td class="colFirst"><code>byte[]</code></td>
<td class="colLast"><code><span class="memberNameLink"><a href="../../../../org/firebirdsql/gds/ng/AbstractFbStatement.html#getParameterDescriptionInfoRequestItems--">getParameterDescriptionInfoRequestItems</a></span>()</code>&nbsp;</td>
</tr>
<tr id="i15" class="rowColor">
<td class="colFirst"><code><a href="../../../../org/firebirdsql/gds/ng/fields/RowDescriptor.html" title="class in org.firebirdsql.gds.ng.fields">RowDescriptor</a></code></td>
<td class="colLast"><code><span class="memberNameLink"><a href="../../../../org/firebirdsql/gds/ng/AbstractFbStatement.html#getParameterDescriptor--">getParameterDescriptor</a></span>()</code>&nbsp;</td>
</tr>
<tr id="i16" class="altColor">
<td class="colFirst"><code><a href="../../../../org/firebirdsql/gds/ng/SqlCountHolder.html" title="class in org.firebirdsql.gds.ng">SqlCountHolder</a></code></td>
<td class="colLast"><code><span class="memberNameLink"><a href="../../../../org/firebirdsql/gds/ng/AbstractFbStatement.html#getSqlCounts--">getSqlCounts</a></span>()</code>
<div class="block">Retrieves the SQL counts for the last execution of this statement.</div>
</td>
</tr>
<tr id="i17" class="rowColor">
<td class="colFirst"><code>&lt;T&gt;&nbsp;T</code></td>
<td class="colLast"><code><span class="memberNameLink"><a href="../../../../org/firebirdsql/gds/ng/AbstractFbStatement.html#getSqlInfo-byte:A-int-org.firebirdsql.gds.ng.InfoProcessor-">getSqlInfo</a></span>(byte[]&nbsp;requestItems,
          int&nbsp;bufferLength,
          <a href="../../../../org/firebirdsql/gds/ng/InfoProcessor.html" title="interface in org.firebirdsql.gds.ng">InfoProcessor</a>&lt;T&gt;&nbsp;infoProcessor)</code>
<div class="block">Request statement info.</div>
</td>
</tr>
<tr id="i18" class="altColor">
<td class="colFirst"><code><a href="../../../../org/firebirdsql/gds/ng/StatementState.html" title="enum in org.firebirdsql.gds.ng">StatementState</a></code></td>
<td class="colLast"><code><span class="memberNameLink"><a href="../../../../org/firebirdsql/gds/ng/AbstractFbStatement.html#getState--">getState</a></span>()</code>&nbsp;</td>
</tr>
<tr id="i19" class="rowColor">
<td class="colFirst"><code>byte[]</code></td>
<td class="colLast"><code><span class="memberNameLink"><a href="../../../../org/firebirdsql/gds/ng/AbstractFbStatement.html#getStatementInfoRequestItems--">getStatementInfoRequestItems</a></span>()</code>&nbsp;</td>
</tr>
<tr id="i20" class="altColor">
<td class="colFirst"><code>protected <a href="../../../../org/firebirdsql/gds/ng/WarningMessageCallback.html" title="interface in org.firebirdsql.gds.ng">WarningMessageCallback</a></code></td>
<td class="colLast"><code><span class="memberNameLink"><a href="../../../../org/firebirdsql/gds/ng/AbstractFbStatement.html#getStatementWarningCallback--">getStatementWarningCallback</a></span>()</code>&nbsp;</td>
</tr>
<tr id="i21" class="rowColor">
<td class="colFirst"><code>protected <a href="https://docs.oracle.com/javase/8/docs/api/java/lang/Object.html?is-external=true" title="class or interface in java.lang">Object</a></code></td>
<td class="colLast"><code><span class="memberNameLink"><a href="../../../../org/firebirdsql/gds/ng/AbstractFbStatement.html#getSynchronizationObject--">getSynchronizationObject</a></span>()</code>
<div class="block">Get synchronization object.</div>
</td>
</tr>
<tr id="i22" class="altColor">
<td class="colFirst"><code><a href="../../../../org/firebirdsql/gds/ng/FbTransaction.html" title="interface in org.firebirdsql.gds.ng">FbTransaction</a></code></td>
<td class="colLast"><code><span class="memberNameLink"><a href="../../../../org/firebirdsql/gds/ng/AbstractFbStatement.html#getTransaction--">getTransaction</a></span>()</code>&nbsp;</td>
</tr>
<tr id="i23" class="rowColor">
<td class="colFirst"><code>protected <a href="../../../../org/firebirdsql/gds/ng/listeners/TransactionListener.html" title="interface in org.firebirdsql.gds.ng.listeners">TransactionListener</a></code></td>
<td class="colLast"><code><span class="memberNameLink"><a href="../../../../org/firebirdsql/gds/ng/AbstractFbStatement.html#getTransactionListener--">getTransactionListener</a></span>()</code>
<div class="block">Gets the <a href="../../../../org/firebirdsql/gds/ng/listeners/TransactionListener.html" title="interface in org.firebirdsql.gds.ng.listeners"><code>TransactionListener</code></a> instance for this statement.</div>
</td>
</tr>
<tr id="i24" class="altColor">
<td class="colFirst"><code><a href="../../../../org/firebirdsql/gds/ng/StatementType.html" title="enum in org.firebirdsql.gds.ng">StatementType</a></code></td>
<td class="colLast"><code><span class="memberNameLink"><a href="../../../../org/firebirdsql/gds/ng/AbstractFbStatement.html#getType--">getType</a></span>()</code>&nbsp;</td>
</tr>
<tr id="i25" class="rowColor">
<td class="colFirst"><code>protected boolean</code></td>
<td class="colLast"><code><span class="memberNameLink"><a href="../../../../org/firebirdsql/gds/ng/AbstractFbStatement.html#hasFields--">hasFields</a></span>()</code>&nbsp;</td>
</tr>
<tr id="i26" class="altColor">
<td class="colFirst"><code>protected boolean</code></td>
<td class="colLast"><code><span class="memberNameLink"><a href="../../../../org/firebirdsql/gds/ng/AbstractFbStatement.html#hasSingletonResult--">hasSingletonResult</a></span>()</code>&nbsp;</td>
</tr>
<tr id="i27" class="rowColor">
<td class="colFirst"><code>protected boolean</code></td>
<td class="colLast"><code><span class="memberNameLink"><a href="../../../../org/firebirdsql/gds/ng/AbstractFbStatement.html#isAllRowsFetched--">isAllRowsFetched</a></span>()</code>&nbsp;</td>
</tr>
<tr id="i28" class="altColor">
<td class="colFirst"><code>protected boolean</code></td>
<td class="colLast"><code><span class="memberNameLink"><a href="../../../../org/firebirdsql/gds/ng/AbstractFbStatement.html#isPrepareAllowed-org.firebirdsql.gds.ng.StatementState-">isPrepareAllowed</a></span>(<a href="../../../../org/firebirdsql/gds/ng/StatementState.html" title="enum in org.firebirdsql.gds.ng">StatementState</a>&nbsp;state)</code>
<div class="block">Is a call to <a href="../../../../org/firebirdsql/gds/ng/FbStatement.html#prepare-java.lang.String-"><code>FbStatement.prepare(String)</code></a> allowed for the supplied <a href="../../../../org/firebirdsql/gds/ng/StatementState.html" title="enum in org.firebirdsql.gds.ng"><code>StatementState</code></a>.</div>
</td>
</tr>
<tr id="i29" class="rowColor">
<td class="colFirst"><code>protected abstract boolean</code></td>
<td class="colLast"><code><span class="memberNameLink"><a href="../../../../org/firebirdsql/gds/ng/AbstractFbStatement.html#isValidTransactionClass-java.lang.Class-">isValidTransactionClass</a></span>(<a href="https://docs.oracle.com/javase/8/docs/api/java/lang/Class.html?is-external=true" title="class or interface in java.lang">Class</a>&lt;? extends <a href="../../../../org/firebirdsql/gds/ng/FbTransaction.html" title="interface in org.firebirdsql.gds.ng">FbTransaction</a>&gt;&nbsp;transactionClass)</code>
<div class="block">Method to decide if a transaction implementation class is valid for the statement implementation.</div>
</td>
</tr>
<tr id="i30" class="altColor">
<td class="colFirst"><code>protected void</code></td>
<td class="colLast"><code><span class="memberNameLink"><a href="../../../../org/firebirdsql/gds/ng/AbstractFbStatement.html#parseStatementInfo-byte:A-">parseStatementInfo</a></span>(byte[]&nbsp;statementInfoResponse)</code>
<div class="block">Parse the statement info response in <code>statementInfoResponse</code>.</div>
</td>
</tr>
<tr id="i31" class="rowColor">
<td class="colFirst"><code>protected void</code></td>
<td class="colLast"><code><span class="memberNameLink"><a href="../../../../org/firebirdsql/gds/ng/AbstractFbStatement.html#queueRowData-org.firebirdsql.gds.ng.fields.RowValue-">queueRowData</a></span>(<a href="../../../../org/firebirdsql/gds/ng/fields/RowValue.html" title="class in org.firebirdsql.gds.ng.fields">RowValue</a>&nbsp;rowData)</code>
<div class="block">Queues row data for consumption</div>
</td>
</tr>
<tr id="i32" class="altColor">
<td class="colFirst"><code>void</code></td>
<td class="colLast"><code><span class="memberNameLink"><a href="../../../../org/firebirdsql/gds/ng/AbstractFbStatement.html#removeExceptionListener-org.firebirdsql.gds.ng.listeners.ExceptionListener-">removeExceptionListener</a></span>(<a href="../../../../org/firebirdsql/gds/ng/listeners/ExceptionListener.html" title="interface in org.firebirdsql.gds.ng.listeners">ExceptionListener</a>&nbsp;listener)</code>
<div class="block">Removes an exception listener to this object.</div>
</td>
</tr>
<tr id="i33" class="rowColor">
<td class="colFirst"><code>void</code></td>
<td class="colLast"><code><span class="memberNameLink"><a href="../../../../org/firebirdsql/gds/ng/AbstractFbStatement.html#removeStatementListener-org.firebirdsql.gds.ng.listeners.StatementListener-">removeStatementListener</a></span>(<a href="../../../../org/firebirdsql/gds/ng/listeners/StatementListener.html" title="interface in org.firebirdsql.gds.ng.listeners">StatementListener</a>&nbsp;statementListener)</code>
<div class="block">Removes a <a href="../../../../org/firebirdsql/gds/ng/listeners/StatementListener.html" title="interface in org.firebirdsql.gds.ng.listeners"><code>StatementListener</code></a>.</div>
</td>
</tr>
<tr id="i34" class="altColor">
<td class="colFirst"><code>protected void</code></td>
<td class="colLast"><code><span class="memberNameLink"><a href="../../../../org/firebirdsql/gds/ng/AbstractFbStatement.html#reset--">reset</a></span>()</code>
<div class="block">Reset statement state, equivalent to calling <a href="../../../../org/firebirdsql/gds/ng/AbstractFbStatement.html#reset-boolean-"><code>reset(boolean)</code></a> with <code>false</code></div>
</td>
</tr>
<tr id="i35" class="rowColor">
<td class="colFirst"><code>protected void</code></td>
<td class="colLast"><code><span class="memberNameLink"><a href="../../../../org/firebirdsql/gds/ng/AbstractFbStatement.html#reset-boolean-">reset</a></span>(boolean&nbsp;resetAll)</code>
<div class="block">Resets the statement for next execution.</div>
</td>
</tr>
<tr id="i36" class="altColor">
<td class="colFirst"><code>protected void</code></td>
<td class="colLast"><code><span class="memberNameLink"><a href="../../../../org/firebirdsql/gds/ng/AbstractFbStatement.html#resetAll--">resetAll</a></span>()</code>
<div class="block">Reset statement state and clear parameter description, equivalent to calling <a href="../../../../org/firebirdsql/gds/ng/AbstractFbStatement.html#reset-boolean-"><code>reset(boolean)</code></a> with <code>true</code></div>
</td>
</tr>
<tr id="i37" class="rowColor">
<td class="colFirst"><code>protected void</code></td>
<td class="colLast"><code><span class="memberNameLink"><a href="../../../../org/firebirdsql/gds/ng/AbstractFbStatement.html#setAllRowsFetched-boolean-">setAllRowsFetched</a></span>(boolean&nbsp;allRowsFetched)</code>
<div class="block">Sets the <code>allRowsFetched</code> property.</div>
</td>
</tr>
<tr id="i38" class="altColor">
<td class="colFirst"><code>protected void</code></td>
<td class="colLast"><code><span class="memberNameLink"><a href="../../../../org/firebirdsql/gds/ng/AbstractFbStatement.html#setFieldDescriptor-org.firebirdsql.gds.ng.fields.RowDescriptor-">setFieldDescriptor</a></span>(<a href="../../../../org/firebirdsql/gds/ng/fields/RowDescriptor.html" title="class in org.firebirdsql.gds.ng.fields">RowDescriptor</a>&nbsp;fieldDescriptor)</code>
<div class="block">Sets the (result set) field descriptor.</div>
</td>
</tr>
<tr id="i39" class="rowColor">
<td class="colFirst"><code>protected void</code></td>
<td class="colLast"><code><span class="memberNameLink"><a href="../../../../org/firebirdsql/gds/ng/AbstractFbStatement.html#setParameterDescriptor-org.firebirdsql.gds.ng.fields.RowDescriptor-">setParameterDescriptor</a></span>(<a href="../../../../org/firebirdsql/gds/ng/fields/RowDescriptor.html" title="class in org.firebirdsql.gds.ng.fields">RowDescriptor</a>&nbsp;parameterDescriptor)</code>
<div class="block">Sets the parameter descriptor.</div>
</td>
</tr>
<tr id="i40" class="altColor">
<td class="colFirst"><code>void</code></td>
<td class="colLast"><code><span class="memberNameLink"><a href="../../../../org/firebirdsql/gds/ng/AbstractFbStatement.html#setTransaction-org.firebirdsql.gds.ng.FbTransaction-">setTransaction</a></span>(<a href="../../../../org/firebirdsql/gds/ng/FbTransaction.html" title="interface in org.firebirdsql.gds.ng">FbTransaction</a>&nbsp;newTransaction)</code>
<div class="block">Associates a transaction with this statement</div>
</td>
</tr>
<tr id="i41" class="rowColor">
<td class="colFirst"><code>protected void</code></td>
<td class="colLast"><code><span class="memberNameLink"><a href="../../../../org/firebirdsql/gds/ng/AbstractFbStatement.html#setType-org.firebirdsql.gds.ng.StatementType-">setType</a></span>(<a href="../../../../org/firebirdsql/gds/ng/StatementType.html" title="enum in org.firebirdsql.gds.ng">StatementType</a>&nbsp;type)</code>
<div class="block">Sets the StatementType</div>
</td>
</tr>
<tr id="i42" class="altColor">
<td class="colFirst"><code>protected void</code></td>
<td class="colLast"><code><span class="memberNameLink"><a href="../../../../org/firebirdsql/gds/ng/AbstractFbStatement.html#switchState-org.firebirdsql.gds.ng.StatementState-">switchState</a></span>(<a href="../../../../org/firebirdsql/gds/ng/StatementState.html" title="enum in org.firebirdsql.gds.ng">StatementState</a>&nbsp;newState)</code>
<div class="block">Sets the StatementState.</div>
</td>
</tr>
<tr id="i43" class="rowColor">
<td class="colFirst"><code>void</code></td>
<td class="colLast"><code><span class="memberNameLink"><a href="../../../../org/firebirdsql/gds/ng/AbstractFbStatement.html#validateParameters-org.firebirdsql.gds.ng.fields.RowValue-">validateParameters</a></span>(<a href="../../../../org/firebirdsql/gds/ng/fields/RowValue.html" title="class in org.firebirdsql.gds.ng.fields">RowValue</a>&nbsp;parameters)</code>
<div class="block">Validates if the number of parameters matches the expected number and types, and if all values have been set.</div>
</td>
</tr>
</table>
<ul class="blockList">
<li class="blockList"><a name="methods.inherited.from.class.java.lang.Object">
<!--   -->
</a>
<h3>Methods inherited from class&nbsp;java.lang.<a href="https://docs.oracle.com/javase/8/docs/api/java/lang/Object.html?is-external=true" title="class or interface in java.lang">Object</a></h3>
<code><a href="https://docs.oracle.com/javase/8/docs/api/java/lang/Object.html?is-external=true#clone--" title="class or interface in java.lang">clone</a>, <a href="https://docs.oracle.com/javase/8/docs/api/java/lang/Object.html?is-external=true#equals-java.lang.Object-" title="class or interface in java.lang">equals</a>, <a href="https://docs.oracle.com/javase/8/docs/api/java/lang/Object.html?is-external=true#getClass--" title="class or interface in java.lang">getClass</a>, <a href="https://docs.oracle.com/javase/8/docs/api/java/lang/Object.html?is-external=true#hashCode--" title="class or interface in java.lang">hashCode</a>, <a href="https://docs.oracle.com/javase/8/docs/api/java/lang/Object.html?is-external=true#notify--" title="class or interface in java.lang">notify</a>, <a href="https://docs.oracle.com/javase/8/docs/api/java/lang/Object.html?is-external=true#notifyAll--" title="class or interface in java.lang">notifyAll</a>, <a href="https://docs.oracle.com/javase/8/docs/api/java/lang/Object.html?is-external=true#toString--" title="class or interface in java.lang">toString</a>, <a href="https://docs.oracle.com/javase/8/docs/api/java/lang/Object.html?is-external=true#wait--" title="class or interface in java.lang">wait</a>, <a href="https://docs.oracle.com/javase/8/docs/api/java/lang/Object.html?is-external=true#wait-long-" title="class or interface in java.lang">wait</a>, <a href="https://docs.oracle.com/javase/8/docs/api/java/lang/Object.html?is-external=true#wait-long-int-" title="class or interface in java.lang">wait</a></code></li>
</ul>
<ul class="blockList">
<li class="blockList"><a name="methods.inherited.from.class.org.firebirdsql.gds.ng.FbStatement">
<!--   -->
</a>
<h3>Methods inherited from interface&nbsp;org.firebirdsql.gds.ng.<a href="../../../../org/firebirdsql/gds/ng/FbStatement.html" title="interface in org.firebirdsql.gds.ng">FbStatement</a></h3>
<code><a href="../../../../org/firebirdsql/gds/ng/FbStatement.html#emptyRowDescriptor--">emptyRowDescriptor</a>, <a href="../../../../org/firebirdsql/gds/ng/FbStatement.html#execute-org.firebirdsql.gds.ng.fields.RowValue-">execute</a>, <a href="../../../../org/firebirdsql/gds/ng/FbStatement.html#fetchRows-int-">fetchRows</a>, <a href="../../../../org/firebirdsql/gds/ng/FbStatement.html#getDatabase--">getDatabase</a>, <a href="../../../../org/firebirdsql/gds/ng/FbStatement.html#getDefaultSqlInfoSize--">getDefaultSqlInfoSize</a>, <a href="../../../../org/firebirdsql/gds/ng/FbStatement.html#getHandle--">getHandle</a>, <a href="../../../../org/firebirdsql/gds/ng/FbStatement.html#getMaxSqlInfoSize--">getMaxSqlInfoSize</a>, <a href="../../../../org/firebirdsql/gds/ng/FbStatement.html#getSqlInfo-byte:A-int-">getSqlInfo</a>, <a href="../../../../org/firebirdsql/gds/ng/FbStatement.html#prepare-java.lang.String-">prepare</a>, <a href="../../../../org/firebirdsql/gds/ng/FbStatement.html#setCursorName-java.lang.String-">setCursorName</a></code></li>
</ul>
</li>
</ul>
</li>
</ul>
</div>
<div class="details">
<ul class="blockList">
<li class="blockList">
<!-- ============ FIELD DETAIL =========== -->
<ul class="blockList">
<li class="blockList"><a name="field.detail">
<!--   -->
</a>
<h3>Field Detail</h3>
<a name="statementListenerDispatcher">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>statementListenerDispatcher</h4>
<pre>protected final&nbsp;<a href="../../../../org/firebirdsql/gds/ng/listeners/StatementListenerDispatcher.html" title="class in org.firebirdsql.gds.ng.listeners">StatementListenerDispatcher</a> statementListenerDispatcher</pre>
</li>
</ul>
<a name="exceptionListenerDispatcher">
<!--   -->
</a>
<ul class="blockListLast">
<li class="blockList">
<h4>exceptionListenerDispatcher</h4>
<pre>protected final&nbsp;<a href="../../../../org/firebirdsql/gds/ng/listeners/ExceptionListenerDispatcher.html" title="class in org.firebirdsql.gds.ng.listeners">ExceptionListenerDispatcher</a> exceptionListenerDispatcher</pre>
</li>
</ul>
</li>
</ul>
<!-- ========= CONSTRUCTOR DETAIL ======== -->
<ul class="blockList">
<li class="blockList"><a name="constructor.detail">
<!--   -->
</a>
<h3>Constructor Detail</h3>
<a name="AbstractFbStatement-java.lang.Object-">
<!--   -->
</a>
<ul class="blockListLast">
<li class="blockList">
<h4>AbstractFbStatement</h4>
<pre>protected&nbsp;AbstractFbStatement(<a href="https://docs.oracle.com/javase/8/docs/api/java/lang/Object.html?is-external=true" title="class or interface in java.lang">Object</a>&nbsp;syncObject)</pre>
</li>
</ul>
</li>
</ul>
<!-- ============ METHOD DETAIL ========== -->
<ul class="blockList">
<li class="blockList"><a name="method.detail">
<!--   -->
</a>
<h3>Method Detail</h3>
<a name="getTransactionListener--">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>getTransactionListener</h4>
<pre>protected final&nbsp;<a href="../../../../org/firebirdsql/gds/ng/listeners/TransactionListener.html" title="interface in org.firebirdsql.gds.ng.listeners">TransactionListener</a>&nbsp;getTransactionListener()</pre>
<div class="block">Gets the <a href="../../../../org/firebirdsql/gds/ng/listeners/TransactionListener.html" title="interface in org.firebirdsql.gds.ng.listeners"><code>TransactionListener</code></a> instance for this statement.
 <p>
 This method should only be called by this object itself. Subclasses may provide their own transaction listener, but
 the instance returned by this method should be the same for the lifetime of this <a href="../../../../org/firebirdsql/gds/ng/FbStatement.html" title="interface in org.firebirdsql.gds.ng"><code>FbStatement</code></a>.
 </p></div>
<dl>
<dt><span class="returnLabel">Returns:</span></dt>
<dd>The transaction listener instance for this statement.</dd>
</dl>
</li>
</ul>
<a name="getStatementWarningCallback--">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>getStatementWarningCallback</h4>
<pre>protected final&nbsp;<a href="../../../../org/firebirdsql/gds/ng/WarningMessageCallback.html" title="interface in org.firebirdsql.gds.ng">WarningMessageCallback</a>&nbsp;getStatementWarningCallback()</pre>
</li>
</ul>
<a name="getSynchronizationObject--">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>getSynchronizationObject</h4>
<pre>protected final&nbsp;<a href="https://docs.oracle.com/javase/8/docs/api/java/lang/Object.html?is-external=true" title="class or interface in java.lang">Object</a>&nbsp;getSynchronizationObject()</pre>
<div class="block">Get synchronization object.</div>
<dl>
<dt><span class="returnLabel">Returns:</span></dt>
<dd>object, cannot be <code>null</code>.</dd>
</dl>
</li>
</ul>
<a name="close--">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>close</h4>
<pre>public&nbsp;void&nbsp;close()
           throws <a href="https://docs.oracle.com/javase/8/docs/api/java/sql/SQLException.html?is-external=true" title="class or interface in java.sql">SQLException</a></pre>
<div class="block"><span class="descfrmTypeLabel">Description copied from interface:&nbsp;<code><a href="../../../../org/firebirdsql/gds/ng/FbStatement.html#close--">FbStatement</a></code></span></div>
<div class="block">Close and deallocate this statement.</div>
<dl>
<dt><span class="overrideSpecifyLabel">Specified by:</span></dt>
<dd><code><a href="../../../../org/firebirdsql/gds/ng/FbStatement.html#close--">close</a></code>&nbsp;in interface&nbsp;<code><a href="../../../../org/firebirdsql/gds/ng/FbStatement.html" title="interface in org.firebirdsql.gds.ng">FbStatement</a></code></dd>
<dt><span class="throwsLabel">Throws:</span></dt>
<dd><code><a href="https://docs.oracle.com/javase/8/docs/api/java/sql/SQLException.html?is-external=true" title="class or interface in java.sql">SQLException</a></code></dd>
</dl>
</li>
</ul>
<a name="closeCursor--">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>closeCursor</h4>
<pre>public final&nbsp;void&nbsp;closeCursor()
                       throws <a href="https://docs.oracle.com/javase/8/docs/api/java/sql/SQLException.html?is-external=true" title="class or interface in java.sql">SQLException</a></pre>
<div class="block"><span class="descfrmTypeLabel">Description copied from interface:&nbsp;<code><a href="../../../../org/firebirdsql/gds/ng/FbStatement.html#closeCursor--">FbStatement</a></code></span></div>
<div class="block">Closes the cursor associated with this statement, leaving the
 statement itself allocated.
 <p>
 Equivalent to calling <a href="../../../../org/firebirdsql/gds/ng/FbStatement.html#closeCursor-boolean-"><code>FbStatement.closeCursor(boolean)</code></a> with <code>false</code>.
 </p></div>
<dl>
<dt><span class="overrideSpecifyLabel">Specified by:</span></dt>
<dd><code><a href="../../../../org/firebirdsql/gds/ng/FbStatement.html#closeCursor--">closeCursor</a></code>&nbsp;in interface&nbsp;<code><a href="../../../../org/firebirdsql/gds/ng/FbStatement.html" title="interface in org.firebirdsql.gds.ng">FbStatement</a></code></dd>
<dt><span class="throwsLabel">Throws:</span></dt>
<dd><code><a href="https://docs.oracle.com/javase/8/docs/api/java/sql/SQLException.html?is-external=true" title="class or interface in java.sql">SQLException</a></code></dd>
</dl>
</li>
</ul>
<a name="closeCursor-boolean-">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>closeCursor</h4>
<pre>public final&nbsp;void&nbsp;closeCursor(boolean&nbsp;transactionEnd)
                       throws <a href="https://docs.oracle.com/javase/8/docs/api/java/sql/SQLException.html?is-external=true" title="class or interface in java.sql">SQLException</a></pre>
<div class="block"><span class="descfrmTypeLabel">Description copied from interface:&nbsp;<code><a href="../../../../org/firebirdsql/gds/ng/FbStatement.html#closeCursor-boolean-">FbStatement</a></code></span></div>
<div class="block">Closes the cursor associated with this statement, leaving the statement itself allocated.
 <p>
 When this method is called in preparation of a commit or rollback (see <code>transactionEnd</code>), then
 implementations may opt to not close the cursor on the server if the server closes the cursor automatically.
 </p></div>
<dl>
<dt><span class="overrideSpecifyLabel">Specified by:</span></dt>
<dd><code><a href="../../../../org/firebirdsql/gds/ng/FbStatement.html#closeCursor-boolean-">closeCursor</a></code>&nbsp;in interface&nbsp;<code><a href="../../../../org/firebirdsql/gds/ng/FbStatement.html" title="interface in org.firebirdsql.gds.ng">FbStatement</a></code></dd>
<dt><span class="paramLabel">Parameters:</span></dt>
<dd><code>transactionEnd</code> - Close is in response to a transaction end.</dd>
<dt><span class="throwsLabel">Throws:</span></dt>
<dd><code><a href="https://docs.oracle.com/javase/8/docs/api/java/sql/SQLException.html?is-external=true" title="class or interface in java.sql">SQLException</a></code></dd>
</dl>
</li>
</ul>
<a name="ensureClosedCursor-boolean-">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>ensureClosedCursor</h4>
<pre>public final&nbsp;void&nbsp;ensureClosedCursor(boolean&nbsp;transactionEnd)
                              throws <a href="https://docs.oracle.com/javase/8/docs/api/java/sql/SQLException.html?is-external=true" title="class or interface in java.sql">SQLException</a></pre>
<div class="block"><span class="descfrmTypeLabel">Description copied from interface:&nbsp;<code><a href="../../../../org/firebirdsql/gds/ng/FbStatement.html#ensureClosedCursor-boolean-">FbStatement</a></code></span></div>
<div class="block">Ensures that the statement cursor is closed. Resets a statement so it is ready to be reused for re-execute or
 prepare.
 <p>
 Implementations should only close an open cursor and log this fact with a stacktrace on debug. This is a stopgap
 measure for situations where the code using this statement handle has not been able to properly close the
 cursor.
 </p></div>
<dl>
<dt><span class="overrideSpecifyLabel">Specified by:</span></dt>
<dd><code><a href="../../../../org/firebirdsql/gds/ng/FbStatement.html#ensureClosedCursor-boolean-">ensureClosedCursor</a></code>&nbsp;in interface&nbsp;<code><a href="../../../../org/firebirdsql/gds/ng/FbStatement.html" title="interface in org.firebirdsql.gds.ng">FbStatement</a></code></dd>
<dt><span class="paramLabel">Parameters:</span></dt>
<dd><code>transactionEnd</code> - Close is in response to a transaction end</dd>
<dt><span class="throwsLabel">Throws:</span></dt>
<dd><code><a href="https://docs.oracle.com/javase/8/docs/api/java/sql/SQLException.html?is-external=true" title="class or interface in java.sql">SQLException</a></code> - If this statement is closed or the cursor could not be closed.</dd>
</dl>
</li>
</ul>
<a name="getState--">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>getState</h4>
<pre>public&nbsp;<a href="../../../../org/firebirdsql/gds/ng/StatementState.html" title="enum in org.firebirdsql.gds.ng">StatementState</a>&nbsp;getState()</pre>
<dl>
<dt><span class="overrideSpecifyLabel">Specified by:</span></dt>
<dd><code><a href="../../../../org/firebirdsql/gds/ng/FbStatement.html#getState--">getState</a></code>&nbsp;in interface&nbsp;<code><a href="../../../../org/firebirdsql/gds/ng/FbStatement.html" title="interface in org.firebirdsql.gds.ng">FbStatement</a></code></dd>
<dt><span class="returnLabel">Returns:</span></dt>
<dd>The current state of this statement</dd>
</dl>
</li>
</ul>
<a name="switchState-org.firebirdsql.gds.ng.StatementState-">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>switchState</h4>
<pre>protected final&nbsp;void&nbsp;switchState(<a href="../../../../org/firebirdsql/gds/ng/StatementState.html" title="enum in org.firebirdsql.gds.ng">StatementState</a>&nbsp;newState)
                          throws <a href="https://docs.oracle.com/javase/8/docs/api/java/sql/SQLException.html?is-external=true" title="class or interface in java.sql">SQLException</a></pre>
<div class="block">Sets the StatementState.</div>
<dl>
<dt><span class="paramLabel">Parameters:</span></dt>
<dd><code>newState</code> - New state</dd>
<dt><span class="throwsLabel">Throws:</span></dt>
<dd><code><a href="https://docs.oracle.com/javase/8/docs/api/java/sql/SQLException.html?is-external=true" title="class or interface in java.sql">SQLException</a></code> - When the state is changed to an illegal next state</dd>
</dl>
</li>
</ul>
<a name="getType--">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>getType</h4>
<pre>public final&nbsp;<a href="../../../../org/firebirdsql/gds/ng/StatementType.html" title="enum in org.firebirdsql.gds.ng">StatementType</a>&nbsp;getType()</pre>
<dl>
<dt><span class="overrideSpecifyLabel">Specified by:</span></dt>
<dd><code><a href="../../../../org/firebirdsql/gds/ng/FbStatement.html#getType--">getType</a></code>&nbsp;in interface&nbsp;<code><a href="../../../../org/firebirdsql/gds/ng/FbStatement.html" title="interface in org.firebirdsql.gds.ng">FbStatement</a></code></dd>
<dt><span class="returnLabel">Returns:</span></dt>
<dd>The statement type</dd>
</dl>
</li>
</ul>
<a name="setType-org.firebirdsql.gds.ng.StatementType-">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>setType</h4>
<pre>protected&nbsp;void&nbsp;setType(<a href="../../../../org/firebirdsql/gds/ng/StatementType.html" title="enum in org.firebirdsql.gds.ng">StatementType</a>&nbsp;type)</pre>
<div class="block">Sets the StatementType</div>
<dl>
<dt><span class="paramLabel">Parameters:</span></dt>
<dd><code>type</code> - New type</dd>
</dl>
</li>
</ul>
<a name="queueRowData-org.firebirdsql.gds.ng.fields.RowValue-">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>queueRowData</h4>
<pre>protected final&nbsp;void&nbsp;queueRowData(<a href="../../../../org/firebirdsql/gds/ng/fields/RowValue.html" title="class in org.firebirdsql.gds.ng.fields">RowValue</a>&nbsp;rowData)</pre>
<div class="block">Queues row data for consumption</div>
<dl>
<dt><span class="paramLabel">Parameters:</span></dt>
<dd><code>rowData</code> - Row data</dd>
</dl>
</li>
</ul>
<a name="setAllRowsFetched-boolean-">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>setAllRowsFetched</h4>
<pre>protected final&nbsp;void&nbsp;setAllRowsFetched(boolean&nbsp;allRowsFetched)</pre>
<div class="block">Sets the <code>allRowsFetched</code> property.
 <p>
 When set to true all registered <a href="../../../../org/firebirdsql/gds/ng/listeners/StatementListener.html" title="interface in org.firebirdsql.gds.ng.listeners"><code>StatementListener</code></a> instances are notified
 for the <a href="../../../../org/firebirdsql/gds/ng/listeners/StatementListener.html#allRowsFetched-org.firebirdsql.gds.ng.FbStatement-"><code>StatementListener.allRowsFetched(FbStatement)</code></a> event.
 </p></div>
<dl>
<dt><span class="paramLabel">Parameters:</span></dt>
<dd><code>allRowsFetched</code> - <code>true</code>: all rows fetched, <code>false</code> not all rows fetched.</dd>
</dl>
</li>
</ul>
<a name="isAllRowsFetched--">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>isAllRowsFetched</h4>
<pre>protected final&nbsp;boolean&nbsp;isAllRowsFetched()</pre>
</li>
</ul>
<a name="reset--">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>reset</h4>
<pre>protected final&nbsp;void&nbsp;reset()</pre>
<div class="block">Reset statement state, equivalent to calling <a href="../../../../org/firebirdsql/gds/ng/AbstractFbStatement.html#reset-boolean-"><code>reset(boolean)</code></a> with <code>false</code></div>
</li>
</ul>
<a name="resetAll--">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>resetAll</h4>
<pre>protected final&nbsp;void&nbsp;resetAll()</pre>
<div class="block">Reset statement state and clear parameter description, equivalent to calling <a href="../../../../org/firebirdsql/gds/ng/AbstractFbStatement.html#reset-boolean-"><code>reset(boolean)</code></a> with <code>true</code></div>
</li>
</ul>
<a name="reset-boolean-">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>reset</h4>
<pre>protected&nbsp;void&nbsp;reset(boolean&nbsp;resetAll)</pre>
<div class="block">Resets the statement for next execution. Implementation in derived class must synchronize on <a href="../../../../org/firebirdsql/gds/ng/AbstractFbStatement.html#getSynchronizationObject--"><code>getSynchronizationObject()</code></a> and
 call <code>super.reset(resetAll)</code></div>
<dl>
<dt><span class="paramLabel">Parameters:</span></dt>
<dd><code>resetAll</code> - Also reset field and parameter info</dd>
</dl>
</li>
</ul>
<a name="isPrepareAllowed-org.firebirdsql.gds.ng.StatementState-">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>isPrepareAllowed</h4>
<pre>protected&nbsp;boolean&nbsp;isPrepareAllowed(<a href="../../../../org/firebirdsql/gds/ng/StatementState.html" title="enum in org.firebirdsql.gds.ng">StatementState</a>&nbsp;state)</pre>
<div class="block">Is a call to <a href="../../../../org/firebirdsql/gds/ng/FbStatement.html#prepare-java.lang.String-"><code>FbStatement.prepare(String)</code></a> allowed for the supplied <a href="../../../../org/firebirdsql/gds/ng/StatementState.html" title="enum in org.firebirdsql.gds.ng"><code>StatementState</code></a>.</div>
<dl>
<dt><span class="paramLabel">Parameters:</span></dt>
<dd><code>state</code> - The statement state</dd>
<dt><span class="returnLabel">Returns:</span></dt>
<dd><code>true</code> call to <code>prepare</code> is allowed</dd>
</dl>
</li>
</ul>
<a name="getParameterDescriptor--">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>getParameterDescriptor</h4>
<pre>public final&nbsp;<a href="../../../../org/firebirdsql/gds/ng/fields/RowDescriptor.html" title="class in org.firebirdsql.gds.ng.fields">RowDescriptor</a>&nbsp;getParameterDescriptor()</pre>
<dl>
<dt><span class="overrideSpecifyLabel">Specified by:</span></dt>
<dd><code><a href="../../../../org/firebirdsql/gds/ng/FbStatement.html#getParameterDescriptor--">getParameterDescriptor</a></code>&nbsp;in interface&nbsp;<code><a href="../../../../org/firebirdsql/gds/ng/FbStatement.html" title="interface in org.firebirdsql.gds.ng">FbStatement</a></code></dd>
<dt><span class="returnLabel">Returns:</span></dt>
<dd>descriptor of the parameters of this statement</dd>
</dl>
</li>
</ul>
<a name="setParameterDescriptor-org.firebirdsql.gds.ng.fields.RowDescriptor-">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>setParameterDescriptor</h4>
<pre>protected&nbsp;void&nbsp;setParameterDescriptor(<a href="../../../../org/firebirdsql/gds/ng/fields/RowDescriptor.html" title="class in org.firebirdsql.gds.ng.fields">RowDescriptor</a>&nbsp;parameterDescriptor)</pre>
<div class="block">Sets the parameter descriptor.</div>
<dl>
<dt><span class="paramLabel">Parameters:</span></dt>
<dd><code>parameterDescriptor</code> - Parameter descriptor</dd>
</dl>
</li>
</ul>
<a name="getFieldDescriptor--">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>getFieldDescriptor</h4>
<pre>public final&nbsp;<a href="../../../../org/firebirdsql/gds/ng/fields/RowDescriptor.html" title="class in org.firebirdsql.gds.ng.fields">RowDescriptor</a>&nbsp;getFieldDescriptor()</pre>
<dl>
<dt><span class="overrideSpecifyLabel">Specified by:</span></dt>
<dd><code><a href="../../../../org/firebirdsql/gds/ng/FbStatement.html#getFieldDescriptor--">getFieldDescriptor</a></code>&nbsp;in interface&nbsp;<code><a href="../../../../org/firebirdsql/gds/ng/FbStatement.html" title="interface in org.firebirdsql.gds.ng">FbStatement</a></code></dd>
<dt><span class="returnLabel">Returns:</span></dt>
<dd>descriptor of the fields returned by this statement</dd>
</dl>
</li>
</ul>
<a name="setFieldDescriptor-org.firebirdsql.gds.ng.fields.RowDescriptor-">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>setFieldDescriptor</h4>
<pre>protected&nbsp;void&nbsp;setFieldDescriptor(<a href="../../../../org/firebirdsql/gds/ng/fields/RowDescriptor.html" title="class in org.firebirdsql.gds.ng.fields">RowDescriptor</a>&nbsp;fieldDescriptor)</pre>
<div class="block">Sets the (result set) field descriptor.</div>
<dl>
<dt><span class="paramLabel">Parameters:</span></dt>
<dd><code>fieldDescriptor</code> - Field descriptor</dd>
</dl>
</li>
</ul>
<a name="getStatementInfoRequestItems--">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>getStatementInfoRequestItems</h4>
<pre>public&nbsp;byte[]&nbsp;getStatementInfoRequestItems()</pre>
<dl>
<dt><span class="returnLabel">Returns:</span></dt>
<dd>The (full) statement info request items.</dd>
<dt><span class="seeLabel">See Also:</span></dt>
<dd><a href="../../../../org/firebirdsql/gds/ng/AbstractFbStatement.html#getParameterDescriptionInfoRequestItems--"><code>getParameterDescriptionInfoRequestItems()</code></a></dd>
</dl>
</li>
</ul>
<a name="getParameterDescriptionInfoRequestItems--">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>getParameterDescriptionInfoRequestItems</h4>
<pre>public&nbsp;byte[]&nbsp;getParameterDescriptionInfoRequestItems()</pre>
<dl>
<dt><span class="returnLabel">Returns:</span></dt>
<dd>The <code>isc_info_sql_describe_vars</code> info request items.</dd>
<dt><span class="seeLabel">See Also:</span></dt>
<dd><a href="../../../../org/firebirdsql/gds/ng/AbstractFbStatement.html#getStatementInfoRequestItems--"><code>getStatementInfoRequestItems()</code></a></dd>
</dl>
</li>
</ul>
<a name="getSqlInfo-byte:A-int-org.firebirdsql.gds.ng.InfoProcessor-">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>getSqlInfo</h4>
<pre>public final&nbsp;&lt;T&gt;&nbsp;T&nbsp;getSqlInfo(byte[]&nbsp;requestItems,
                              int&nbsp;bufferLength,
                              <a href="../../../../org/firebirdsql/gds/ng/InfoProcessor.html" title="interface in org.firebirdsql.gds.ng">InfoProcessor</a>&lt;T&gt;&nbsp;infoProcessor)
                       throws <a href="https://docs.oracle.com/javase/8/docs/api/java/sql/SQLException.html?is-external=true" title="class or interface in java.sql">SQLException</a></pre>
<div class="block">Request statement info.</div>
<dl>
<dt><span class="overrideSpecifyLabel">Specified by:</span></dt>
<dd><code><a href="../../../../org/firebirdsql/gds/ng/FbStatement.html#getSqlInfo-byte:A-int-org.firebirdsql.gds.ng.InfoProcessor-">getSqlInfo</a></code>&nbsp;in interface&nbsp;<code><a href="../../../../org/firebirdsql/gds/ng/FbStatement.html" title="interface in org.firebirdsql.gds.ng">FbStatement</a></code></dd>
<dt><span class="paramLabel">Parameters:</span></dt>
<dd><code>requestItems</code> - Array of info items to request</dd>
<dd><code>bufferLength</code> - Response buffer length to use</dd>
<dd><code>infoProcessor</code> - Implementation of <a href="../../../../org/firebirdsql/gds/ng/InfoProcessor.html" title="interface in org.firebirdsql.gds.ng"><code>InfoProcessor</code></a> to transform
         the info response</dd>
<dt><span class="returnLabel">Returns:</span></dt>
<dd>Transformed info response of type T</dd>
<dt><span class="throwsLabel">Throws:</span></dt>
<dd><code><a href="https://docs.oracle.com/javase/8/docs/api/java/sql/SQLException.html?is-external=true" title="class or interface in java.sql">SQLException</a></code> - For errors retrieving or transforming the response.</dd>
</dl>
</li>
</ul>
<a name="getExecutionPlan--">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>getExecutionPlan</h4>
<pre>public final&nbsp;<a href="https://docs.oracle.com/javase/8/docs/api/java/lang/String.html?is-external=true" title="class or interface in java.lang">String</a>&nbsp;getExecutionPlan()
                              throws <a href="https://docs.oracle.com/javase/8/docs/api/java/sql/SQLException.html?is-external=true" title="class or interface in java.sql">SQLException</a></pre>
<dl>
<dt><span class="overrideSpecifyLabel">Specified by:</span></dt>
<dd><code><a href="../../../../org/firebirdsql/gds/ng/FbStatement.html#getExecutionPlan--">getExecutionPlan</a></code>&nbsp;in interface&nbsp;<code><a href="../../../../org/firebirdsql/gds/ng/FbStatement.html" title="interface in org.firebirdsql.gds.ng">FbStatement</a></code></dd>
<dt><span class="returnLabel">Returns:</span></dt>
<dd>The execution plan of the currently prepared statement</dd>
<dt><span class="throwsLabel">Throws:</span></dt>
<dd><code><a href="https://docs.oracle.com/javase/8/docs/api/java/sql/SQLException.html?is-external=true" title="class or interface in java.sql">SQLException</a></code> - If this statement is closed.</dd>
</dl>
</li>
</ul>
<a name="getExplainedExecutionPlan--">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>getExplainedExecutionPlan</h4>
<pre>public final&nbsp;<a href="https://docs.oracle.com/javase/8/docs/api/java/lang/String.html?is-external=true" title="class or interface in java.lang">String</a>&nbsp;getExplainedExecutionPlan()
                                       throws <a href="https://docs.oracle.com/javase/8/docs/api/java/sql/SQLException.html?is-external=true" title="class or interface in java.sql">SQLException</a></pre>
<dl>
<dt><span class="overrideSpecifyLabel">Specified by:</span></dt>
<dd><code><a href="../../../../org/firebirdsql/gds/ng/FbStatement.html#getExplainedExecutionPlan--">getExplainedExecutionPlan</a></code>&nbsp;in interface&nbsp;<code><a href="../../../../org/firebirdsql/gds/ng/FbStatement.html" title="interface in org.firebirdsql.gds.ng">FbStatement</a></code></dd>
<dt><span class="returnLabel">Returns:</span></dt>
<dd>The detailed execution plan of the currently prepared statement</dd>
<dt><span class="throwsLabel">Throws:</span></dt>
<dd><code><a href="https://docs.oracle.com/javase/8/docs/api/java/sql/SQLException.html?is-external=true" title="class or interface in java.sql">SQLException</a></code> - If this statement is closed.</dd>
</dl>
</li>
</ul>
<a name="createExecutionPlanProcessor--">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>createExecutionPlanProcessor</h4>
<pre>protected&nbsp;<a href="../../../../org/firebirdsql/gds/ng/ExecutionPlanProcessor.html" title="class in org.firebirdsql.gds.ng">ExecutionPlanProcessor</a>&nbsp;createExecutionPlanProcessor()</pre>
<dl>
<dt><span class="returnLabel">Returns:</span></dt>
<dd>New instance of <a href="../../../../org/firebirdsql/gds/ng/ExecutionPlanProcessor.html" title="class in org.firebirdsql.gds.ng"><code>ExecutionPlanProcessor</code></a> (or subclass) for this statement.</dd>
</dl>
</li>
</ul>
<a name="getSqlCounts--">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>getSqlCounts</h4>
<pre>public&nbsp;<a href="../../../../org/firebirdsql/gds/ng/SqlCountHolder.html" title="class in org.firebirdsql.gds.ng">SqlCountHolder</a>&nbsp;getSqlCounts()
                            throws <a href="https://docs.oracle.com/javase/8/docs/api/java/sql/SQLException.html?is-external=true" title="class or interface in java.sql">SQLException</a></pre>
<div class="block"><span class="descfrmTypeLabel">Description copied from interface:&nbsp;<code><a href="../../../../org/firebirdsql/gds/ng/FbStatement.html#getSqlCounts--">FbStatement</a></code></span></div>
<div class="block">Retrieves the SQL counts for the last execution of this statement.
 <p>
 The retrieved SQL counts are also notified to all registered <a href="../../../../org/firebirdsql/gds/ng/listeners/StatementListener.html" title="interface in org.firebirdsql.gds.ng.listeners"><code>StatementListener</code></a>s.
 </p>
 <p>
 In general the <a href="../../../../org/firebirdsql/gds/ng/FbStatement.html" title="interface in org.firebirdsql.gds.ng"><code>FbStatement</code></a> will (should) retrieve and notify listeners of the SQL counts automatically at times were
 it is relevant (eg after executing a statement that does not produce multiple rows, or after fetching all rows).
 </p></div>
<dl>
<dt><span class="overrideSpecifyLabel">Specified by:</span></dt>
<dd><code><a href="../../../../org/firebirdsql/gds/ng/FbStatement.html#getSqlCounts--">getSqlCounts</a></code>&nbsp;in interface&nbsp;<code><a href="../../../../org/firebirdsql/gds/ng/FbStatement.html" title="interface in org.firebirdsql.gds.ng">FbStatement</a></code></dd>
<dt><span class="returnLabel">Returns:</span></dt>
<dd>The SQL counts of the last execution of this statement</dd>
<dt><span class="throwsLabel">Throws:</span></dt>
<dd><code><a href="https://docs.oracle.com/javase/8/docs/api/java/sql/SQLException.html?is-external=true" title="class or interface in java.sql">SQLException</a></code> - If this statement is closed, or if this statement is in state <a href="../../../../org/firebirdsql/gds/ng/StatementState.html#CURSOR_OPEN"><code>StatementState.CURSOR_OPEN</code></a> and not
         all rows have been fetched.</dd>
</dl>
</li>
</ul>
<a name="createSqlCountProcessor--">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>createSqlCountProcessor</h4>
<pre>protected&nbsp;<a href="../../../../org/firebirdsql/gds/ng/SqlCountProcessor.html" title="class in org.firebirdsql.gds.ng">SqlCountProcessor</a>&nbsp;createSqlCountProcessor()</pre>
<dl>
<dt><span class="returnLabel">Returns:</span></dt>
<dd>New instance of <a href="../../../../org/firebirdsql/gds/ng/SqlCountProcessor.html" title="class in org.firebirdsql.gds.ng"><code>SqlCountProcessor</code></a> (or subclass) for this statement.</dd>
</dl>
</li>
</ul>
<a name="free-int-">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>free</h4>
<pre>protected abstract&nbsp;void&nbsp;free(int&nbsp;option)
                      throws <a href="https://docs.oracle.com/javase/8/docs/api/java/sql/SQLException.html?is-external=true" title="class or interface in java.sql">SQLException</a></pre>
<div class="block">Frees the currently allocated statement (either close the cursor with <a href="../../../../org/firebirdsql/gds/ISCConstants.html#DSQL_close"><code>ISCConstants.DSQL_close</code></a> or drop the statement
 handle using <a href="../../../../org/firebirdsql/gds/ISCConstants.html#DSQL_drop"><code>ISCConstants.DSQL_drop</code></a>.</div>
<dl>
<dt><span class="paramLabel">Parameters:</span></dt>
<dd><code>option</code> - Free option</dd>
<dt><span class="throwsLabel">Throws:</span></dt>
<dd><code><a href="https://docs.oracle.com/javase/8/docs/api/java/sql/SQLException.html?is-external=true" title="class or interface in java.sql">SQLException</a></code></dd>
</dl>
</li>
</ul>
<a name="validateParameters-org.firebirdsql.gds.ng.fields.RowValue-">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>validateParameters</h4>
<pre>public final&nbsp;void&nbsp;validateParameters(<a href="../../../../org/firebirdsql/gds/ng/fields/RowValue.html" title="class in org.firebirdsql.gds.ng.fields">RowValue</a>&nbsp;parameters)
                              throws <a href="https://docs.oracle.com/javase/8/docs/api/java/sql/SQLException.html?is-external=true" title="class or interface in java.sql">SQLException</a></pre>
<div class="block"><span class="descfrmTypeLabel">Description copied from interface:&nbsp;<code><a href="../../../../org/firebirdsql/gds/ng/FbStatement.html#validateParameters-org.firebirdsql.gds.ng.fields.RowValue-">FbStatement</a></code></span></div>
<div class="block">Validates if the number of parameters matches the expected number and types, and if all values have been set.</div>
<dl>
<dt><span class="overrideSpecifyLabel">Specified by:</span></dt>
<dd><code><a href="../../../../org/firebirdsql/gds/ng/FbStatement.html#validateParameters-org.firebirdsql.gds.ng.fields.RowValue-">validateParameters</a></code>&nbsp;in interface&nbsp;<code><a href="../../../../org/firebirdsql/gds/ng/FbStatement.html" title="interface in org.firebirdsql.gds.ng">FbStatement</a></code></dd>
<dt><span class="paramLabel">Parameters:</span></dt>
<dd><code>parameters</code> - Parameter values to validate</dd>
<dt><span class="throwsLabel">Throws:</span></dt>
<dd><code><a href="https://docs.oracle.com/javase/8/docs/api/java/sql/SQLException.html?is-external=true" title="class or interface in java.sql">SQLException</a></code> - When the number or type of parameters does not match <a href="../../../../org/firebirdsql/gds/ng/FbStatement.html#getParameterDescriptor--"><code>FbStatement.getParameterDescriptor()</code></a>, or when a
         parameter has not been set.</dd>
</dl>
</li>
</ul>
<a name="addStatementListener-org.firebirdsql.gds.ng.listeners.StatementListener-">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>addStatementListener</h4>
<pre>public final&nbsp;void&nbsp;addStatementListener(<a href="../../../../org/firebirdsql/gds/ng/listeners/StatementListener.html" title="interface in org.firebirdsql.gds.ng.listeners">StatementListener</a>&nbsp;statementListener)</pre>
<div class="block"><span class="descfrmTypeLabel">Description copied from interface:&nbsp;<code><a href="../../../../org/firebirdsql/gds/ng/FbStatement.html#addStatementListener-org.firebirdsql.gds.ng.listeners.StatementListener-">FbStatement</a></code></span></div>
<div class="block">Registers a <a href="../../../../org/firebirdsql/gds/ng/listeners/StatementListener.html" title="interface in org.firebirdsql.gds.ng.listeners"><code>StatementListener</code></a>.</div>
<dl>
<dt><span class="overrideSpecifyLabel">Specified by:</span></dt>
<dd><code><a href="../../../../org/firebirdsql/gds/ng/FbStatement.html#addStatementListener-org.firebirdsql.gds.ng.listeners.StatementListener-">addStatementListener</a></code>&nbsp;in interface&nbsp;<code><a href="../../../../org/firebirdsql/gds/ng/FbStatement.html" title="interface in org.firebirdsql.gds.ng">FbStatement</a></code></dd>
<dt><span class="paramLabel">Parameters:</span></dt>
<dd><code>statementListener</code> - The row listener</dd>
</dl>
</li>
</ul>
<a name="removeStatementListener-org.firebirdsql.gds.ng.listeners.StatementListener-">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>removeStatementListener</h4>
<pre>public final&nbsp;void&nbsp;removeStatementListener(<a href="../../../../org/firebirdsql/gds/ng/listeners/StatementListener.html" title="interface in org.firebirdsql.gds.ng.listeners">StatementListener</a>&nbsp;statementListener)</pre>
<div class="block"><span class="descfrmTypeLabel">Description copied from interface:&nbsp;<code><a href="../../../../org/firebirdsql/gds/ng/FbStatement.html#removeStatementListener-org.firebirdsql.gds.ng.listeners.StatementListener-">FbStatement</a></code></span></div>
<div class="block">Removes a <a href="../../../../org/firebirdsql/gds/ng/listeners/StatementListener.html" title="interface in org.firebirdsql.gds.ng.listeners"><code>StatementListener</code></a>.</div>
<dl>
<dt><span class="overrideSpecifyLabel">Specified by:</span></dt>
<dd><code><a href="../../../../org/firebirdsql/gds/ng/FbStatement.html#removeStatementListener-org.firebirdsql.gds.ng.listeners.StatementListener-">removeStatementListener</a></code>&nbsp;in interface&nbsp;<code><a href="../../../../org/firebirdsql/gds/ng/FbStatement.html" title="interface in org.firebirdsql.gds.ng">FbStatement</a></code></dd>
<dt><span class="paramLabel">Parameters:</span></dt>
<dd><code>statementListener</code> - The row listener</dd>
</dl>
</li>
</ul>
<a name="addExceptionListener-org.firebirdsql.gds.ng.listeners.ExceptionListener-">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>addExceptionListener</h4>
<pre>public final&nbsp;void&nbsp;addExceptionListener(<a href="../../../../org/firebirdsql/gds/ng/listeners/ExceptionListener.html" title="interface in org.firebirdsql.gds.ng.listeners">ExceptionListener</a>&nbsp;listener)</pre>
<div class="block"><span class="descfrmTypeLabel">Description copied from interface:&nbsp;<code><a href="../../../../org/firebirdsql/gds/ng/listeners/ExceptionListenable.html#addExceptionListener-org.firebirdsql.gds.ng.listeners.ExceptionListener-">ExceptionListenable</a></code></span></div>
<div class="block">Adds an exception listener to this object.
 <p>
 Implementations use <code>WeakReference</code>.
 </p></div>
<dl>
<dt><span class="overrideSpecifyLabel">Specified by:</span></dt>
<dd><code><a href="../../../../org/firebirdsql/gds/ng/listeners/ExceptionListenable.html#addExceptionListener-org.firebirdsql.gds.ng.listeners.ExceptionListener-">addExceptionListener</a></code>&nbsp;in interface&nbsp;<code><a href="../../../../org/firebirdsql/gds/ng/listeners/ExceptionListenable.html" title="interface in org.firebirdsql.gds.ng.listeners">ExceptionListenable</a></code></dd>
<dt><span class="paramLabel">Parameters:</span></dt>
<dd><code>listener</code> - Listener to register</dd>
</dl>
</li>
</ul>
<a name="removeExceptionListener-org.firebirdsql.gds.ng.listeners.ExceptionListener-">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>removeExceptionListener</h4>
<pre>public final&nbsp;void&nbsp;removeExceptionListener(<a href="../../../../org/firebirdsql/gds/ng/listeners/ExceptionListener.html" title="interface in org.firebirdsql.gds.ng.listeners">ExceptionListener</a>&nbsp;listener)</pre>
<div class="block"><span class="descfrmTypeLabel">Description copied from interface:&nbsp;<code><a href="../../../../org/firebirdsql/gds/ng/listeners/ExceptionListenable.html#removeExceptionListener-org.firebirdsql.gds.ng.listeners.ExceptionListener-">ExceptionListenable</a></code></span></div>
<div class="block">Removes an exception listener to this object.</div>
<dl>
<dt><span class="overrideSpecifyLabel">Specified by:</span></dt>
<dd><code><a href="../../../../org/firebirdsql/gds/ng/listeners/ExceptionListenable.html#removeExceptionListener-org.firebirdsql.gds.ng.listeners.ExceptionListener-">removeExceptionListener</a></code>&nbsp;in interface&nbsp;<code><a href="../../../../org/firebirdsql/gds/ng/listeners/ExceptionListenable.html" title="interface in org.firebirdsql.gds.ng.listeners">ExceptionListenable</a></code></dd>
<dt><span class="paramLabel">Parameters:</span></dt>
<dd><code>listener</code> - Listener to remove</dd>
</dl>
</li>
</ul>
<a name="checkStatementValid--">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>checkStatementValid</h4>
<pre>protected final&nbsp;void&nbsp;checkStatementValid()
                                  throws <a href="https://docs.oracle.com/javase/8/docs/api/java/sql/SQLException.html?is-external=true" title="class or interface in java.sql">SQLException</a></pre>
<div class="block">Checks if this statement is not in <a href="../../../../org/firebirdsql/gds/ng/StatementState.html#CLOSED"><code>StatementState.CLOSED</code></a>, <a href="../../../../org/firebirdsql/gds/ng/StatementState.html#CLOSING"><code>StatementState.CLOSING</code></a>,
 <a href="../../../../org/firebirdsql/gds/ng/StatementState.html#NEW"><code>StatementState.NEW</code></a> or <a href="../../../../org/firebirdsql/gds/ng/StatementState.html#ERROR"><code>StatementState.ERROR</code></a>, and throws an <code>SQLException</code> if it is.</div>
<dl>
<dt><span class="throwsLabel">Throws:</span></dt>
<dd><code><a href="https://docs.oracle.com/javase/8/docs/api/java/sql/SQLException.html?is-external=true" title="class or interface in java.sql">SQLException</a></code> - When this statement is closed or in error state.</dd>
</dl>
</li>
</ul>
<a name="finalize--">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>finalize</h4>
<pre>protected&nbsp;void&nbsp;finalize()
                 throws <a href="https://docs.oracle.com/javase/8/docs/api/java/lang/Throwable.html?is-external=true" title="class or interface in java.lang">Throwable</a></pre>
<dl>
<dt><span class="overrideSpecifyLabel">Overrides:</span></dt>
<dd><code><a href="https://docs.oracle.com/javase/8/docs/api/java/lang/Object.html?is-external=true#finalize--" title="class or interface in java.lang">finalize</a></code>&nbsp;in class&nbsp;<code><a href="https://docs.oracle.com/javase/8/docs/api/java/lang/Object.html?is-external=true" title="class or interface in java.lang">Object</a></code></dd>
<dt><span class="throwsLabel">Throws:</span></dt>
<dd><code><a href="https://docs.oracle.com/javase/8/docs/api/java/lang/Throwable.html?is-external=true" title="class or interface in java.lang">Throwable</a></code></dd>
</dl>
</li>
</ul>
<a name="getTransaction--">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>getTransaction</h4>
<pre>public&nbsp;<a href="../../../../org/firebirdsql/gds/ng/FbTransaction.html" title="interface in org.firebirdsql.gds.ng">FbTransaction</a>&nbsp;getTransaction()</pre>
<dl>
<dt><span class="overrideSpecifyLabel">Specified by:</span></dt>
<dd><code><a href="../../../../org/firebirdsql/gds/ng/FbStatement.html#getTransaction--">getTransaction</a></code>&nbsp;in interface&nbsp;<code><a href="../../../../org/firebirdsql/gds/ng/FbStatement.html" title="interface in org.firebirdsql.gds.ng">FbStatement</a></code></dd>
<dt><span class="returnLabel">Returns:</span></dt>
<dd>Transaction currently associated with this statement</dd>
</dl>
</li>
</ul>
<a name="isValidTransactionClass-java.lang.Class-">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>isValidTransactionClass</h4>
<pre>protected abstract&nbsp;boolean&nbsp;isValidTransactionClass(<a href="https://docs.oracle.com/javase/8/docs/api/java/lang/Class.html?is-external=true" title="class or interface in java.lang">Class</a>&lt;? extends <a href="../../../../org/firebirdsql/gds/ng/FbTransaction.html" title="interface in org.firebirdsql.gds.ng">FbTransaction</a>&gt;&nbsp;transactionClass)</pre>
<div class="block">Method to decide if a transaction implementation class is valid for the statement implementation.
 <p>
 Eg a <a href="../../../../org/firebirdsql/gds/ng/wire/version10/V10Statement.html" title="class in org.firebirdsql.gds.ng.wire.version10"><code>V10Statement</code></a> will only work with an
 <a href="../../../../org/firebirdsql/gds/ng/wire/FbWireTransaction.html" title="interface in org.firebirdsql.gds.ng.wire"><code>FbWireTransaction</code></a> implementation.
 </p></div>
<dl>
<dt><span class="paramLabel">Parameters:</span></dt>
<dd><code>transactionClass</code> - Class of the transaction</dd>
<dt><span class="returnLabel">Returns:</span></dt>
<dd><code>true</code> when the transaction class is valid for the statement implementation.</dd>
</dl>
</li>
</ul>
<a name="setTransaction-org.firebirdsql.gds.ng.FbTransaction-">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>setTransaction</h4>
<pre>public final&nbsp;void&nbsp;setTransaction(<a href="../../../../org/firebirdsql/gds/ng/FbTransaction.html" title="interface in org.firebirdsql.gds.ng">FbTransaction</a>&nbsp;newTransaction)
                          throws <a href="https://docs.oracle.com/javase/8/docs/api/java/sql/SQLException.html?is-external=true" title="class or interface in java.sql">SQLException</a></pre>
<div class="block"><span class="descfrmTypeLabel">Description copied from interface:&nbsp;<code><a href="../../../../org/firebirdsql/gds/ng/FbStatement.html#setTransaction-org.firebirdsql.gds.ng.FbTransaction-">FbStatement</a></code></span></div>
<div class="block">Associates a transaction with this statement</div>
<dl>
<dt><span class="overrideSpecifyLabel">Specified by:</span></dt>
<dd><code><a href="../../../../org/firebirdsql/gds/ng/FbStatement.html#setTransaction-org.firebirdsql.gds.ng.FbTransaction-">setTransaction</a></code>&nbsp;in interface&nbsp;<code><a href="../../../../org/firebirdsql/gds/ng/FbStatement.html" title="interface in org.firebirdsql.gds.ng">FbStatement</a></code></dd>
<dt><span class="paramLabel">Parameters:</span></dt>
<dd><code>newTransaction</code> - The transaction</dd>
<dt><span class="throwsLabel">Throws:</span></dt>
<dd><code><a href="https://docs.oracle.com/javase/8/docs/api/java/sql/SQLException.html?is-external=true" title="class or interface in java.sql">SQLException</a></code></dd>
</dl>
</li>
</ul>
<a name="parseStatementInfo-byte:A-">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>parseStatementInfo</h4>
<pre>protected&nbsp;void&nbsp;parseStatementInfo(byte[]&nbsp;statementInfoResponse)
                           throws <a href="https://docs.oracle.com/javase/8/docs/api/java/sql/SQLException.html?is-external=true" title="class or interface in java.sql">SQLException</a></pre>
<div class="block">Parse the statement info response in <code>statementInfoResponse</code>. If the response is truncated, a new
 request is done using <a href="../../../../org/firebirdsql/gds/ng/AbstractFbStatement.html#getStatementInfoRequestItems--"><code>getStatementInfoRequestItems()</code></a></div>
<dl>
<dt><span class="paramLabel">Parameters:</span></dt>
<dd><code>statementInfoResponse</code> - Statement info response</dd>
<dt><span class="throwsLabel">Throws:</span></dt>
<dd><code><a href="https://docs.oracle.com/javase/8/docs/api/java/sql/SQLException.html?is-external=true" title="class or interface in java.sql">SQLException</a></code></dd>
</dl>
</li>
</ul>
<a name="hasSingletonResult--">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>hasSingletonResult</h4>
<pre>protected final&nbsp;boolean&nbsp;hasSingletonResult()</pre>
<dl>
<dt><span class="returnLabel">Returns:</span></dt>
<dd><code>true</code> if this is a stored procedure (or other singleton result producing statement) with at least 1 output field</dd>
</dl>
</li>
</ul>
<a name="hasFields--">
<!--   -->
</a>
<ul class="blockListLast">
<li class="blockList">
<h4>hasFields</h4>
<pre>protected final&nbsp;boolean&nbsp;hasFields()</pre>
<dl>
<dt><span class="returnLabel">Returns:</span></dt>
<dd><code>true</code> if this statement has at least one output field (either singleton or result set)</dd>
</dl>
</li>
</ul>
</li>
</ul>
</li>
</ul>
</div>
</div>
<!-- ========= END OF CLASS DATA ========= -->
<!-- ======= START OF BOTTOM NAVBAR ====== -->
<div class="bottomNav"><a name="navbar.bottom">
<!--   -->
</a>
<div class="skipNav"><a href="#skip.navbar.bottom" title="Skip navigation links">Skip navigation links</a></div>
<a name="navbar.bottom.firstrow">
<!--   -->
</a>
<ul class="navList" title="Navigation">
<li><a href="../../../../overview-summary.html">Overview</a></li>
<li><a href="package-summary.html">Package</a></li>
<li class="navBarCell1Rev">Class</li>
<li><a href="package-tree.html">Tree</a></li>
<li><a href="../../../../deprecated-list.html">Deprecated</a></li>
<li><a href="../../../../index-all.html">Index</a></li>
<li><a href="../../../../help-doc.html">Help</a></li>
</ul>
</div>
<div class="subNav">
<ul class="navList">
<li><a href="../../../../org/firebirdsql/gds/ng/AbstractFbService.html" title="class in org.firebirdsql.gds.ng"><span class="typeNameLink">Prev&nbsp;Class</span></a></li>
<li><a href="../../../../org/firebirdsql/gds/ng/AbstractFbTransaction.html" title="class in org.firebirdsql.gds.ng"><span class="typeNameLink">Next&nbsp;Class</span></a></li>
</ul>
<ul class="navList">
<li><a href="../../../../index.html?org/firebirdsql/gds/ng/AbstractFbStatement.html" target="_top">Frames</a></li>
<li><a href="AbstractFbStatement.html" target="_top">No&nbsp;Frames</a></li>
</ul>
<ul class="navList" id="allclasses_navbar_bottom">
<li><a href="../../../../allclasses-noframe.html">All&nbsp;Classes</a></li>
</ul>
<div>
<script type="text/javascript"><!--
  allClassesLink = document.getElementById("allclasses_navbar_bottom");
  if(window==top) {
    allClassesLink.style.display = "block";
  }
  else {
    allClassesLink.style.display = "none";
  }
  //-->
</script>
</div>
<div>
<ul class="subNavList">
<li>Summary:&nbsp;</li>
<li>Nested&nbsp;|&nbsp;</li>
<li><a href="#field.summary">Field</a>&nbsp;|&nbsp;</li>
<li><a href="#constructor.summary">Constr</a>&nbsp;|&nbsp;</li>
<li><a href="#method.summary">Method</a></li>
</ul>
<ul class="subNavList">
<li>Detail:&nbsp;</li>
<li><a href="#field.detail">Field</a>&nbsp;|&nbsp;</li>
<li><a href="#constructor.detail">Constr</a>&nbsp;|&nbsp;</li>
<li><a href="#method.detail">Method</a></li>
</ul>
</div>
<a name="skip.navbar.bottom">
<!--   -->
</a></div>
<!-- ======== END OF BOTTOM NAVBAR ======= -->
<p class="legalCopy"><small>Copyright &copy; 2001-2019 Jaybird (Firebird JDBC/JCA) team. All rights reserved.</small></p>
</body>
</html>
